// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::Bin;
use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlDockOverlayEdge")]
    pub struct DockOverlayEdge(Object<ffi::DzlDockOverlayEdge, ffi::DzlDockOverlayEdgeClass>) @extends Bin, gtk::Bin, gtk::Container, gtk::Widget, @implements gtk::Buildable;

    match fn {
        type_ => || ffi::dzl_dock_overlay_edge_get_type(),
    }
}

impl DockOverlayEdge {
    #[doc(alias = "dzl_dock_overlay_edge_get_edge")]
    #[doc(alias = "get_edge")]
    pub fn edge(&self) -> gtk::PositionType {
        unsafe { from_glib(ffi::dzl_dock_overlay_edge_get_edge(self.to_glib_none().0)) }
    }

    #[doc(alias = "dzl_dock_overlay_edge_get_position")]
    #[doc(alias = "get_position")]
    pub fn position(&self) -> i32 {
        unsafe { ffi::dzl_dock_overlay_edge_get_position(self.to_glib_none().0) }
    }

    #[doc(alias = "dzl_dock_overlay_edge_set_edge")]
    pub fn set_edge(&self, edge: gtk::PositionType) {
        unsafe {
            ffi::dzl_dock_overlay_edge_set_edge(self.to_glib_none().0, edge.into_glib());
        }
    }

    #[doc(alias = "dzl_dock_overlay_edge_set_position")]
    pub fn set_position(&self, position: i32) {
        unsafe {
            ffi::dzl_dock_overlay_edge_set_position(self.to_glib_none().0, position);
        }
    }

    #[doc(alias = "edge")]
    pub fn connect_edge_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_edge_trampoline<F: Fn(&DockOverlayEdge) + 'static>(
            this: *mut ffi::DzlDockOverlayEdge,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::edge\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_edge_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "position")]
    pub fn connect_position_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_position_trampoline<F: Fn(&DockOverlayEdge) + 'static>(
            this: *mut ffi::DzlDockOverlayEdge,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::position\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_position_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl fmt::Display for DockOverlayEdge {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("DockOverlayEdge")
    }
}
